package it.eng.console.process.action;

import java.util.List;

import org.spagic.metadb.model.SearchQuery;

import it.eng.console.process.bo.QueryBean;
import it.eng.console.query.bo.QueryBO;
import it.eng.console.util.Constants;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

public class DeleteQueryAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String idQuery = (String)serviceRequest.getAttribute(Constants.LBL_ID_QUERY);
		QueryBO.deleteQuery(idQuery);
		loadListQuery(serviceResponse);
	}
	
	protected void loadListQuery(SourceBean serviceResponse) throws Exception{
		SourceBean queryBeanList = new SourceBean("LIST");
		
		List<SearchQuery> queryList = QueryBO.getQueryList();
		//create response
		SearchQuery query = null;
		for(int indexQuery=0; indexQuery<queryList.size(); indexQuery++) {
			query = (SearchQuery)queryList.get(indexQuery);
			if (query!=null) {
				queryBeanList.setAttribute(createQueryBean(query));
			}
		}
		System.out.println("Numero elementi recuperati="+queryList.size());
		serviceResponse.setAttribute(queryBeanList);
	}
	
	protected SourceBean createQueryBean(SearchQuery query)	throws SourceBeanException {		
	SourceBean item = null;
	long idProcess;
	try {
		item = new SourceBean("ITEM");
		item.setAttribute("id_query", query.getIdQuery());
		item.setAttribute("label", query.getLabel());				
		item.setAttribute("query", query.getQuery());
	} catch(SourceBeanException sbe) {
		TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ProcessSearchAction::createQueryBean:: ", sbe);
		throw sbe;
	}
	return item;

}

}
