package it.eng.console.process.action;

import it.eng.console.process.bo.QueryBean;
import it.eng.console.query.bo.QueryBO;
import it.eng.console.util.Constants;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

public class SaveQueryAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String nameQuery = (String)serviceRequest.getAttribute("nameQuery");
		Long numQuery = QueryBO.getQueryByLabel(nameQuery);
		if(numQuery>0){
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "SaveQueryAction::service: Label della query gia' presente sul db");
			serviceResponse.setAttribute("message", MessageBundle.getMessage("10019", "properties.console.messages"));
			return;
		}
		
		// recupero la query dalla sessionContainer e faccio insert sul db
		SessionContainer sessionContainer = getRequestContainer().getSessionContainer();
		QueryBean bean = (QueryBean)sessionContainer.getAttribute(Constants.LBL_QUERY);
		
		if(bean!=null){
			XStream xstream = new XStream(new DomDriver());
			xstream.alias("bean", QueryBean.class);
			String xmlBeanQuery = xstream.toXML(bean);
			try{
				
				QueryBO.insertQuery(xmlBeanQuery,nameQuery);
				serviceResponse.setAttribute("message", MessageBundle.getMessage("10018", "properties.console.messages"));
			}catch(Exception e){
				serviceResponse.setAttribute("message", MessageBundle.getMessage("10017", "properties.console.messages"));
				// gestire errore
			}
		}else{
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "SaveQueryAction::service: Nessuna query trovata nel sessionContainer");
			serviceResponse.setAttribute("message", MessageBundle.getMessage("10017", "properties.console.messages"));
		}
		return;
	}

}
