/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.query.bo;

import it.eng.console.hibernate.util.HibernateSessionFactory;
import it.eng.console.util.Constants;
import it.eng.spago.tracing.TracerSingleton;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.Order;
import org.spagic.metadb.model.SearchQuery;

public class QueryBO {
	public static List<SearchQuery>  getQueryList() throws HibernateException{
		Criteria criteria = null;
		try {
			Session session = HibernateSessionFactory.getSessionFactory().getCurrentSession();
			criteria = session.createCriteria(SearchQuery.class).addOrder(Order.asc("label"));									
			return criteria.list();
		} catch(HibernateException he) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "QueryBO::getQueryList: ", he);
			throw he;
		}
	}
	
	public static void deleteQuery(String idQuery)throws HibernateException{
		Session session = null;
		try{
			session = HibernateSessionFactory.getSessionFactory().getCurrentSession();
			SearchQuery query = (SearchQuery)session.get(SearchQuery.class, new Long(idQuery));
			session.delete(query);
		}catch(HibernateException he){
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "QueryBO::deleteQuery:: ", he);
			throw he;
		}
	}
	
	public static void insertQuery(String query,String label) throws HibernateException{
		Session session = null;
		
		try{
			session = HibernateSessionFactory.getSessionFactory().getCurrentSession();
			SearchQuery queryObj = new SearchQuery();
			queryObj.setQuery(query);
			queryObj.setLabel(label);
			
			session.save(queryObj);
		}catch(HibernateException he){
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "QueryBO::insertQuery:: ", he);
			throw he;
		}
	}
	
	public static Long getLastQuery(){
		Session session = null;
		try{
			session = HibernateSessionFactory.getSessionFactory().getCurrentSession();
			SearchQuery queryObj = new SearchQuery();
			String query = "select max(idQuery) from SearchQuery";  
			Query getLastQuery = session.createQuery(query);
			List result = getLastQuery.list();
			if(result!=null && result.size()>0){
				System.out.println("last ="+result.get(0));
				return (Long)result.get(0);
			}
			return null;
		}catch(HibernateException he){
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "QueryBO::insertQuery:: ", he);
			throw he;
		}
	}
	
	public static String getQuery(Long queryId)  throws HibernateException{
		Session session = null;
		try {
			session = HibernateSessionFactory.getSessionFactory().getCurrentSession();
			SearchQuery query = (SearchQuery)session.get(SearchQuery.class, queryId);
			return query.getQuery();
		} catch(HibernateException he) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "QueryBO::getQuery: ", he);
			throw he;
		}
	}	
	
	public static Long getQueryByLabel(String label)  throws HibernateException{
		Session session = null;
		long numQuery = 0;
		try{
			
			session = HibernateSessionFactory.getSessionFactory().getCurrentSession();
			String hqlString = "SELECT count(label) "
							+ " FROM SearchQuery query "
							+ " WHERE query.label = :label";
			Query query = session.createQuery(hqlString);
			query.setString("label", label);
			numQuery = (Long)query.list().get(0);
			return numQuery;
			
		}catch(HibernateException he){
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "QueryBO::getQueryByLabel:: ", he);
			throw he;
		}
	}
}	
