/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.tag;

import it.eng.console.util.Constants;
import it.eng.console.util.DateFormatter;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.RequestContainerAccess;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.ResponseContainerAccess;
import it.eng.spago.tracing.TracerSingleton;

import java.text.DateFormat;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import org.spagic.metadb.base.TransitionStateUtils;

public class MessagesListTag extends TagSupport {
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "MessagesListTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "MessagesListTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        HttpServletRequest httpRequest = null;
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "MessagesListTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "MessagesListTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        }
        ResponseContainer responseContainer =
            ResponseContainerAccess.getResponseContainer(httpRequest);
        if(responseContainer == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "MessagesListTag::doStartTag:: httpRequest nullo");
            throw new JspException("responseContainer nullo");
        }   
        RequestContainer requestContainer = 
        	RequestContainerAccess.getRequestContainer(httpRequest);
        StringBuffer output = new StringBuffer(); 
       
        List messagesList= (List)responseContainer.getServiceResponse().getAttribute("MESSAGESLISTMODULE.LIST");
		int indexMessage;
		List message;
		DateFormat formatter = DateFormatter.getShortDateTimeFormat(requestContainer.getSessionContainer());
		String endDate = null;
		for(indexMessage=0; indexMessage<messagesList.size();indexMessage++) {
			message = (List)messagesList.get(indexMessage);
			output.append("<tr>\n");			
			output.append("<td>" + message.get(0) + "</td>\n");
			output.append("<td>" + message.get(1) + "</td>\n");
			output.append("<td>");
			if (TransitionStateUtils.isActiveState((Integer)message.get(2)))
				output.append("<img src=\"" + httpRequest.getContextPath() + "/images/console/wait.gif\"/>");
			else if (TransitionStateUtils.isFaultState((Integer)message.get(2)))
				output.append("<img src=\"" + httpRequest.getContextPath() + "/images/console/fault.gif\"/>");
			else
				output.append("<img src=\"" + httpRequest.getContextPath() + "/images/console/executed.gif\"/>");
			output.append("</td>");

			output.append("<td>" + formatter.format(message.get(3)) + "</td>\n");
			endDate = (message.get(4) !=null)
						? formatter.format(message.get(4))
						: "";
			output.append("<td>" + endDate + "&nbsp;</td>\n");
			output.append("<td><a href=\"#\" onclick=\"loadLogsJournal(" + message.get(0) + ");return false;\">XML</a></td>\n");
			output.append("</tr>\n");
		}
        try {
            pageContext.getOut().print(output.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "MessagesListTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        return SKIP_BODY;
    }
    
	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "MessagesListTag::doEndTag:: invocato");
        return super.doEndTag();
    } 

}
